<?php
/**
 * Created by PhpStorm.
 * User: crose
 * Date: 1/28/16
 * Time: 8:05 AM
 */

namespace qfq;

require_once(__DIR__ . '/Sanatize.php');

class Support {

    /**
     * @param array $queryArray Empty or prefilled assoc array with url parameter
     */
    public static function appendTypo3ParameterToArray(array &$queryArray) {
//        if (isset($_GET['id']))
//            $queryArray['id'] = self::getCurrentPage();
        if (isset($GLOBALS["TSFE"]->id))
            $queryArray['id'] = $GLOBALS["TSFE"]->id;

        if (isset($_GET['L']))
            $queryArray['L'] = $_GET['L'];

        if (isset($_GET['type']))
            $queryArray['type'] = $_GET['type'];

    }

    /**
     * Builds a urlencoded query string of an assoc array.
     *
     * @param array $queryArray
     * @return string Querystring (e.g.: id=23&type=99
     */
    public static function arrayToQueryString(array $queryArray) {
        $items = array();

        foreach ($queryArray as $key => $value) {
            if (is_int($key)) {
                $items[] = urlencode($value);
            } else {
                $items[] = $key . '=' . urlencode($value);
            }
        }

        return implode('&', $items);
    }

    /**
     * @throws CodeException
     */
    public static function log($text) {

        $logFile = __DIR__ . '/../../../' . QFQ_LOG;

        if (!is_writable($logFile)) {
            throw new CodeException ("The file (" . dirname($_SERVER['SCRIPT_FILENAME']) . '/) ' . $logFile . " is not writable ()", ERROR_LOG_NOT_WRITABLE);
        }

        if (!$handle = fopen($logFile, 'a')) {
            throw new CodeException ("Cannot open file to append: " . $logFile, ERROR_LOG_NOT_WRITABLE);
        }

        if (fwrite($handle, $text . chr(10)) === FALSE) {
            throw new CodeException ("Cannot write to file: " . $logFile, ERROR_LOG_NOT_WRITABLE);
        }
        fclose($handle);
    }
}