<?php
/**
 * Created by PhpStorm.
 * User: crose
 * Date: 1/2/16
 * Time: 11:10 PM
 */

namespace qfq;

//use qfq\Sanatize;
//use qfq\exceptions\CodeException;

require_once(__DIR__ . '/../../qfq/helper/Sanatize.php');
require_once(__DIR__ . '/../../qfq/exceptions/CodeException.php');


class SanatizeTest extends \PHPUnit_Framework_TestCase {

    public function testSanatize() {

        # Violates SANATIZE class: sanatized string is always an empty string.
        # Access are cached: use new variables for every test.

        # Check '1'
        $this->assertEquals('1', Sanatize::sanatize('1', SANATIZE_ALLOW_DIGIT), "SANATIZE_DIGIT fails");
        $this->assertEquals('1', Sanatize::sanatize('1', SANATIZE_ALLOW_ALNUMX), "SANATIZE_ALNUMX fails");
        $this->assertEquals('1', Sanatize::sanatize('1', SANATIZE_ALLOW_ALL), "SANATIZE_ALL fails");

        # Check '-3'
        $this->assertEquals('-3', Sanatize::sanatize('-3', SANATIZE_ALLOW_DIGIT), "SANATIZE_DIGIT fails");
        $this->assertEquals('-3', Sanatize::sanatize('-3', SANATIZE_ALLOW_ALNUMX), "SANATIZE_ALNUMX fails");
        $this->assertEquals('-3', Sanatize::sanatize('-3', SANATIZE_ALLOW_ALL), "SANATIZE_ALL fails");

        # Check 'a'
        $this->assertEquals('', Sanatize::sanatize('a', SANATIZE_ALLOW_DIGIT), "SANATIZE_DIGIT fails");
        $this->assertEquals('a', Sanatize::sanatize('a', SANATIZE_ALLOW_ALNUMX), "SANATIZE_ALNUMX fails");
        $this->assertEquals('a', Sanatize::sanatize('a', SANATIZE_ALLOW_ALL), "SANATIZE_ALL fails");


        # Check 'a@-_.,;Z09'
        $this->assertEquals('', Sanatize::sanatize('a@-_.,;Z09', SANATIZE_ALLOW_DIGIT), "SANATIZE_DIGIT fails");
        $this->assertEquals('a@-_.,;Z09', Sanatize::sanatize('a@-_.,;Z09', SANATIZE_ALLOW_ALNUMX), "SANATIZE_ALNUMX fails");
        $this->assertEquals('a@-_.,;Z09', Sanatize::sanatize('a@-_.,;Z09', SANATIZE_ALLOW_ALL), "SANATIZE_ALL fails");

        # Check 'a+Z09'
        $this->assertEquals('', Sanatize::sanatize('a+Z09', SANATIZE_ALLOW_DIGIT), "SANATIZE_DIGIT fails");
        $this->assertEquals('', Sanatize::sanatize('a+Z09', SANATIZE_ALLOW_ALNUMX), "SANATIZE_ALNUMX fails");
        $this->assertEquals('a+Z09', Sanatize::sanatize('a+Z09', SANATIZE_ALLOW_ALL), "SANATIZE_ALL fails");
    }

    /**
     * @expectedException \qfq\CodeException
     *
     */
    public function testSanatizeException() {
        Sanatize::sanatize('Hello World', 'invalid sanatize class');
    }

}
