<?php
/**
 * Created by PhpStorm.
 * User: crose
 * Date: 1/28/16
 * Time: 9:58 AM
 */

namespace qfq;

require_once(__DIR__ . '/../../qfq/helper/Support.php');

class FakeTSFE {
    public $id = 1;
}

class SupportTest extends \PHPUnit_Framework_TestCase {

    public function testAppendTypo3ParameterToArray() {

        unset($_GET);

        $GLOBALS["TSFE"] = new FakeTSFE();
        $queryArray = array();
        Support::appendTypo3ParameterToArray($queryArray);
        $this->assertEquals(['id' => 1], $queryArray);

        $queryArray = ['id' => '1', 'a' => '100'];
        $expected = $queryArray;
        Support::appendTypo3ParameterToArray($queryArray);
        $this->assertEquals($expected, $queryArray);

        $_GET['L'] = 1;
        $_GET['type'] = 100;
        $queryArray = ['id' => '1', 'a' => '100'];
        $expected = array_merge($_GET, $queryArray);
        Support::appendTypo3ParameterToArray($queryArray);
        $this->assertEquals($expected, $queryArray);

        unset($_GET);
        $_GET['L'] = 1;
        $queryArray = ['id' => '1', 'a' => '100'];
        $expected = array_merge($_GET, $queryArray);
        Support::appendTypo3ParameterToArray($queryArray);
        $this->assertEquals($expected, $queryArray);

        unset($_GET);
        $_GET['type'] = 1;
        $queryArray = ['id' => '1', 'a' => '100'];
        $expected = array_merge($_GET, $queryArray);
        Support::appendTypo3ParameterToArray($queryArray);
        $this->assertEquals($expected, $queryArray);

    }

    public function testArrayToQueryString() {
        $actual = Support::arrayToQueryString(array());
        $expected = '';
        $this->assertEquals($expected, $actual);

        $actual = Support::arrayToQueryString(['id', 'name']);
        $expected = '';
        $this->assertEquals('id&name', $actual);

        $actual = Support::arrayToQueryString(['id' => '55', 'name']);
        $expected = '';
        $this->assertEquals('id=55&name', $actual);

        $actual = Support::arrayToQueryString(['id' => '55', 'name' => 'Heinz']);
        $expected = '';
        $this->assertEquals('id=55&name=Heinz', $actual);

        $actual = Support::arrayToQueryString(['id' => '55', 'name' => 'He<b>inz']);
        $expected = '';
        $this->assertEquals('id=55&name=He%3Cb%3Einz', $actual);

    }
}
